## grandorgue 3.14.2

=== src/grandorgue/CMakeLists.txt ===
# Copyright 2006 Milan Digital Audio LLC
# Copyright 2009-2024 GrandOrgue contributors (see AUTHORS)
# License GPL-2.0 or later (https://www.gnu.org/licenses/old-licenses/gpl-2.0.html).

include(${CMAKE_SOURCE_DIR}/cmake/AddLinkerOption.cmake)
include(${CMAKE_SOURCE_DIR}/cmake/CopyWxTranslations.cmake)
include(${CMAKE_SOURCE_DIR}/cmake/CopyDependencies.cmake)

add_option(-mmmx)
add_option(-msse)
add_option(-msse2)
add_option(-msse3)

add_option(-mstackrealign)

find_package(wxWidgets REQUIRED html net adv core base)
include(${wxWidgets_USE_FILE})
if (APPLE)
  # /usr/local/share/cmake/yaml-cpp/yaml-cpp-config.cmake sets
  # empty YAML_CPP_INCLUDE_DIR and YAML_CPP_LIBRARIES, so we use pkg_config
  pkg_check_modules(YAML_CPP REQUIRED yaml-cpp)
else()
  # but pkg_config does not support static linking for yaml-cpp, so use cmake config
  ## at first, try to find static package
  set(CMAKE_FIND_DEBUG_MODE TRUE)
  find_package(yaml-cpp REQUIRED)
  set(CMAKE_FIND_DEBUG_MODE FALSE)
  message("yaml-cpp_CONFIG=${yaml-cpp_CONFIG}")
  include("${yaml-cpp_CONFIG}")
  # the variables are different in both methods
  set(YAML_CPP_INCLUDE_DIRS "${YAML_CPP_INCLUDE_DIR}")
endif()

message("YAML_CPP_INCLUDE_DIRS=${YAML_CPP_INCLUDE_DIRS}")
message("YAML_CPP_LIBRARIES=${YAML_CPP_LIBRARIES}")

include_directories(${CMAKE_BINARY_DIR}/src/core/go_defs.h ${CMAKE_CURRENT_SOURCE_DIR}/resource ${CMAKE_SOURCE_DIR}/src/core)
include_directories(${RT_INCLUDE_DIRS})
include_directories(${PORTAUDIO_INCLUDE_DIRS})
include_directories(${ZITACONVOLVER_INCLUDE_DIRS})
include_directories(${FFTW_INCLUDE_DIRS})
include_directories(${wxWidgets_INCLUDE_DIRS})
include_directories(${JACK_INCLUDE_DIRS})
include_directories(${YAML_CPP_INCLUDE_DIRS})
include_directories(${CMAKE_CURRENT_SOURCE_DIR})

set(grandorgue_src
combinations/control/GOCombinationButtonSet.cpp
combinations/control/GOCombinationControllerProxy.cpp
combinations/control/GODivisionalButtonControl.cpp
combinations/control/GOGeneralButtonControl.cpp
combinations/model/GOCombination.cpp
combinations/model/GOCombinationDefinition.cpp
combinations/model/GODivisionalCombination.cpp
combinations/model/GOGeneralCombination.cpp
combinations/GODivisionalSetter.cpp
combinations/GOSetter.cpp
config/GOConfig.cpp
config/GOMidiDeviceConfig.cpp
config/GOMidiDeviceConfigList.cpp
config/GOPortsConfig.cpp
config/GOPortFactory.cpp
control/GOButtonControl.cpp
control/GOCallbackButtonControl.cpp
control/GOElementCreator.cpp
control/GOEventDistributor.cpp
control/GOLabelControl.cpp
control/GOPistonControl.cpp
dialogs/common/GODialogCloser.cpp
dialogs/common/GODialogSizeSet.cpp
dialogs/common/GODialogTab.cpp
dialogs/common/GOSimpleDialog.cpp
dialogs/common/GOTabbedDialog.cpp
dialogs/midi-event/GOMidiEventDialog.cpp
dialogs/midi-event/GOMidiEventKeyTab.cpp
dialogs/midi-event/GOMidiEventRecvTab.cpp
dialogs/midi-event/GOMidiEventSendTab.cpp
dialogs/settings/GOSettingsAudio.cpp
dialogs/settings/GOSettingsDialog.cpp
dialogs/settings/GOSettingsMidiDeviceList.cpp
dialogs/settings/GOSettingsMidiDevices.cpp
dialogs/settings/GOSettingsMidiMatchDialog.cpp
dialogs/settings/GOSettingsMidiMessage.cpp
dialogs/settings/GOSettingsPaths.cpp
dialogs/settings/GOSettingsPorts.cpp
dialogs/settings/GOSettingsOptions.cpp
dialogs/settings/GOSettingsOrgans.cpp
dialogs/settings/GOSettingsReverb.cpp
dialogs/settings/GOSettingsTemperaments.cpp
dialogs/GOMidiListDialog.cpp
dialogs/GONewReleaseDialog.cpp
dialogs/GOOrganSettingsDialog.cpp
dialogs/GOProgressDialog.cpp
dialogs/GOSelectOrganDialog.cpp
dialogs/GOSplash.cpp
document-base/GODocumentBase.cpp
document-base/GOView.cpp
gui/primitives/GOBitmap.cpp
gui/primitives/GODC.cpp
gui/primitives/GOFont.cpp
gui/primitives/go_gui_utils.cpp
gui/GOGUIBankedGeneralsPanel.cpp
gui/GOGUIButton.cpp
gui/GOGUICrescendoPanel.cpp
gui/GOGUIControl.cpp
gui/GOGUICouplerPanel.cpp
gui/GOGUIDisplayMetrics.cpp
gui/GOGUIDivisionalsPanel.cpp
gui/GOGUIEnclosure.cpp
gui/GOGUIFloatingPanel.cpp
gui/GOGUIHW1Background.cpp
gui/GOGUIHW1DisplayMetrics.cpp
gui/GOGUIImage.cpp
gui/GOGUILayoutEngine.cpp
gui/GOGUIPanelView.cpp
gui/GOGUISetterDisplayMetrics.cpp
gui/GOGUILabel.cpp
gui/GOGUIManual.cpp
gui/GOGUIManualBackground.cpp
gui/GOGUIMasterPanel.cpp
gui/GOGUIMetronomePanel.cpp
gui/GOGUIPanel.cpp
gui/GOGUIPanelWidget.cpp
gui/GOGUIRecorderPanel.cpp
gui/GOGUISequencerPanel.cpp
help/GOHelpController.cpp
help/GOHelpRequestor.cpp
loader/GOFileStore.cpp
loader/GOLoaderFilename.cpp
loader/GOLoadThread.cpp
loader/GOLoadWorker.cpp
loader/cache/GOCache.cpp
loader/cache/GOCacheCleaner.cpp
loader/cache/GOCacheWriter.cpp
midi/dialog-creator/GOMidiDialogCreatorProxy.cpp
midi/ports/GOMidiInPort.cpp
midi/ports/GOMidiOutPort.cpp
midi/ports/GOMidiPort.cpp
midi/ports/GOMidiPortFactory.cpp
midi/ports/GOMidiRtPortFactory.cpp
midi/ports/GOMidiRtInPort.cpp
midi/ports/GOMidiRtOutPort.cpp
midi/GOMidi.cpp
midi/GOMidiConfigurator.cpp
midi/GOMidiInputMerger.cpp
midi/GOMidiListener.cpp
midi/GOMidiOutputMerger.cpp
midi/GOMidiPlayer.cpp
midi/GOMidiPlayerContent.cpp
midi/GOMidiSendProxy.cpp
midi/GOMidiSender.cpp
midi/GOMidiShortcutPattern.cpp
midi/GOMidiShortcutReceiver.cpp
midi/GOMidiReceiver.cpp
midi/GOMidiRecorder.cpp
model/pipe-config/GOPipeConfig.cpp
model/pipe-config/GOPipeConfigNode.cpp
model/pipe-config/GOPipeConfigTreeNode.cpp
model/GOCacheObject.cpp
model/GOCoupler.cpp
model/GODivisionalCoupler.cpp
model/GODrawStop.cpp
model/GOEnclosure.cpp
model/GOEventHandlerList.cpp
model/GOManual.cpp
model/GOOrganModel.cpp
model/GOPipe.cpp
model/GORank.cpp
model/GOReferencePipe.cpp
model/GOSoundingPipe.cpp
model/GOStop.cpp
model/GOSwitch.cpp
model/GOTremulant.cpp
model/GOWindchest.cpp
modification/GOModificationProxy.cpp
size/GOSizeKeeper.cpp
sound/ports/GOSoundJackPort.cpp
sound/ports/GOSoundPort.cpp
sound/ports/GOSoundPortFactory.cpp
sound/ports/GOSoundPortaudioPort.cpp
sound/ports/GOSoundRtPort.cpp
sound/scheduler/GOSoundGroupWorkItem.cpp
sound/scheduler/GOSoundOutputWorkItem.cpp
sound/scheduler/GOSoundReleaseWorkItem.cpp
sound/scheduler/GOSoundScheduler.cpp
sound/scheduler/GOSoundThread.cpp
sound/scheduler/GOSoundTouchWorkItem.cpp
sound/scheduler/GOSoundTremulantWorkItem.cpp
sound/scheduler/GOSoundWindchestWorkItem.cpp
sound/GOSoundAudioSection.cpp
sound/GOSoundEngine.cpp
sound/GOSoundProvider.cpp
sound/GOSoundProviderSynthedTrem.cpp
sound/GOSoundProviderWave.cpp
sound/GOSoundRecorder.cpp
sound/GOSoundReleaseAlignTable.cpp
sound/GOSoundReverb.cpp
sound/GOSoundReverbEngine.cpp
sound/GOSoundReverbPartition.cpp
sound/GOSoundResample.cpp
sound/GOSoundSamplerPool.cpp
sound/GOSoundStateHandler.cpp
sound/GOSound.cpp
updater/GOUpdateChecker.cpp
yaml/GOSaveableToYaml.cpp
yaml/go-wx-yaml.cpp
wxcontrols/GOAudioGauge.cpp
wxcontrols/GOGrid.cpp
wxcontrols/GORightVisiblePicker.cpp
GOAudioRecorder.cpp
GOBitmapCache.cpp
GOEvent.cpp
GOLog.cpp
GOLogWindow.cpp
GOMetronome.cpp
GOMainWindowData.cpp
GOOrganController.cpp
GOProperties.cpp
GOFrame.cpp
GODocument.cpp
GOVirtualCouplerController.cpp
)

if (USE_INTERNAL_ZITACONVOLVER)
  list(APPEND grandorgue_src ${CMAKE_SOURCE_DIR}/submodules/ZitaConvolver/source/zita-convolver.cc)
endif()

add_library(golib STATIC ${grandorgue_src})
set(go_libs ${wxWidgets_LIBRARIES} ${YAML_CPP_LIBRARIES} ${RT_LIBRARIES} ${PORTAUDIO_LIBRARIES} ${FFTW_LIBRARIES} ${ZITACONVOLVER_LIBRARIES} CURL::libcurl)
set(go_libdir ${wxWidgets_LIBRARY_DIRS} ${RT_LIBDIR} ${PORTAUDIO_LIBDIR} ${FFTW_LIBDIR})
target_link_libraries(golib GrandOrgueImages GrandOrgueCore ${go_libs})
link_directories(${go_libdir})

if (WIN32)
  set_source_files_properties("${RESOURCEDIR}/GrandOrgue.rc" PROPERTIES GENERATED "YES")
  add_executable(GrandOrgue WIN32 GOApp.cpp "${RESOURCEDIR}/GrandOrgue.rc")
  add_dependencies(GrandOrgue resources) # GrandOrgue.rc and GrandOrgue.manifest & GOIcon.ico referenced from GrandOrgue.rc
  add_linker_option(GrandOrgue large-address-aware)
else ()
   add_executable(GrandOrgue GOApp.cpp)
endif ()

BUILD_EXECUTABLE(GrandOrgue)
target_link_libraries(GrandOrgue golib)

if (INSTALL_DEPEND STREQUAL "ON")
  CopyWxTranslations()
  CopyDependencies(GrandOrgue "${BININSTDIR}/GrandOrgue${CMAKE_EXECUTABLE_SUFFIX}" ${go_libs} ${go_libdir})
endif()

if (GO_USE_JACK)
   add_definitions(-DGO_USE_JACK)
   target_link_libraries(golib PkgConfig::JACK)
endif ()

=== debian/changelog ===
grandorgue (3.14.2-2) unstable; urgency=medium

  * Upload to unstable, for rtaudio 6 transition

 -- Sébastien Villemot <sebastien@debian.org>  Fri, 21 Jun 2024 11:36:15 +0200

grandorgue (3.14.2-1) experimental; urgency=medium

  * New upstream version 3.14.2

 -- Sébastien Villemot <sebastien@debian.org>  Fri, 03 May 2024 11:17:52 +0200

=== debian/control ===
Source: grandorgue
Maintainer: Sébastien Villemot <sebastien@debian.org>
Section: sound
Priority: optional
Build-Depends: debhelper-compat (= 13),
               cmake,
               libjack-dev,
               librtaudio-dev (>= 6),
               librtmidi-dev,
               portaudio19-dev,
               libfftw3-dev,
               zlib1g-dev,
               libwavpack-dev,
               libwxgtk3.2-dev,
               libzita-convolver-dev,
               libyaml-cpp-dev,
               libcurl4-openssl-dev,
               imagemagick-6.q16,
               librsvg2-bin,
               gettext,
               xsltproc,
               docbook-xsl,
               zip,
               po4a
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/debian/grandorgue
Vcs-Git: https://salsa.debian.org/debian/grandorgue.git
Homepage: https://github.com/GrandOrgue/grandorgue
Rules-Requires-Root: no

Package: grandorgue
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Recommends: grandorgue-demo
Description: sample-based pipe organ simulator
 GrandOrgue allows the user to load and play virtual pipe organs.
 Using sample sets, GrandOrgue is able to combine the individual pipe
 sounds and organ behaviors to simulate a variety of pipe organs.
 .
 When connected to MIDI keyboards and an audio system, it can accurately
 simulate the sound of a real pipe organ.
 .
 The user can create and load organ samplesets using a dedicated file format. A
 demonstration organ sampleset is provided in the grandorgue-demo package.

Package: grandorgue-demo
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Enhances: grandorgue
Description: sample-based pipe organ simulator (demo sampleset)
 GrandOrgue allows the user to load and play virtual pipe organs.
 Using sample sets, GrandOrgue is able to combine the individual pipe
 sounds and organ behaviors to simulate a variety of pipe organs.
 .
 This package contains a demonstration organ sampleset.

## grandorgue 3.15.0

=== CMakeLists.txt ===
# Copyright 2006 Milan Digital Audio LLC
# Copyright 2009-2024 GrandOrgue contributors (see AUTHORS)
# License GPL-2.0 or later
# (https://www.gnu.org/licenses/old-licenses/gpl-2.0.html).

cmake_minimum_required(VERSION 3.10)

# Project version numbers
if(NOT DEFINED VERSION)
  file(STRINGS "version.txt" VERSION)
  if(NOT VERSION)
    message(FATAL_ERROR "Unable to get version from version.txt")
  endif()
endif()

project(
  GrandOrgue
  VERSION "${VERSION}"
  DESCRIPTION "GrandOrgue - free pipe organ simulator"
  LANGUAGES CXX C
  HOMEPAGE_URL "https://github.com/GrandOrgue/grandorgue"
)
set(NUM_VERSION "${PROJECT_VERSION}")
string(REPLACE "." "," NUM_WIN_VERSION ${NUM_VERSION})

if(NOT DEFINED BUILD_VERSION)
  set(BUILD_VERSION "0.local")
elseif(NOT BUILD_VERSION)
  set(BUILD_VERSION "0.0")
endif()

set(FULL_VERSION "${PROJECT_VERSION}-${BUILD_VERSION}")

# Set GITHUB_PROJECT variable that is used to configure update checking
if (NOT DEFINED GITHUB_PROJECT)
  set(GITHUB_PROJECT "GrandOrgue/grandorgue")
endif()

# Define a c++ standard
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_STANDARD 17 CACHE STRING "The C++ standard whose features are requested to build this project")

# Build configuration options
option(RTAUDIO_USE_CORE       "Enable RtAudio support for Core Audio (Rt and PortAudio - OS X only)" ON)
option(RTAUDIO_USE_JACK       "Enable RtAudio support for Jack (Rt and PortAudio)" ON)
option(RTAUDIO_USE_OSS        "Enable RtAudio support for OSS (Rt and PortAudio - Linux only)" OFF)
option(RTAUDIO_USE_ALSA       "Enable RtAudio support for ALSA (Rt and PortAudio - Linux only)" ON)
option(RTAUDIO_USE_DSOUND     "Enable RtAudio support for DirectSound (Rt and PortAudio - Windows only)" ON)
option(RTAUDIO_USE_ASIO       "Enable RtAudio support for ASIO (Rt and PortAudio - Windows only)" ON)
option(RTAUDIO_USE_WMME       "Enable RtAudio support for WMME (PortAudio only - Windows only)" ON)
option(RTAUDIO_USE_WDMKS      "Enable RtAudio support for WDMKS (PortAudio only - Windows only)" ON)
option(RTAUDIO_USE_WASAPI     "Enable RtAudio support for WASAPI (PortAudio only - Windows only)" ON)
option(RTMIDI_USE_CORE        "Enable RtMidi support for Core Audio (OS X only)" ON)
option(RTMIDI_USE_JACK        "Enable RtMidi support for Jack" ON)
option(RTMIDI_USE_ALSA        "Enable RtMidi support for ALSA (Linux only)" ON)
option(RTMIDI_USE_MM          "Enable RtMidi support for MM (Windows only)" ON)
option(USE_INTERNAL_RTAUDIO   "Use builtin RtAudio/RtMidi sources" ON)
option(INSTALL_DEMO           "Install demo sampleset" ON)
option(USE_INTERNAL_PORTAUDIO "Use builtin PortAudio sources" ON)
option(USE_INTERNAL_ZITACONVOLVER "Use builtin Zita Convolver sources" ON)
option(GO_USE_JACK	      "Use native Jack output" ON)
if (WIN32 OR APPLE)
   option(INSTALL_DEPEND      "Copy dependencies (wxWidgets libraries and Translations) on installation" ON)
else ()
   option(INSTALL_DEPEND      "Copy dependencies (wxWidgets libraries and Translations) on installation" OFF)
endif ()
option(GO_SEPARATE_LINUX_PACKAGES "Generate separate linux packages for resources and demo" OFF)
option(USE_BUILD_SYSTEM_LIBDIR "Use build system (distro-specific) libdir (Linux only)" OFF)

# only use options supported by the compiler
include(CheckIncludeFileCXX)
include(CheckFunctionExists)
include(FindPkgConfig)
include(${CMAKE_SOURCE_DIR}/cmake/AddOption.cmake)
include(${CMAKE_SOURCE_DIR}/cmake/AddCXXOption.cmake)
include(${CMAKE_SOURCE_DIR}/cmake/FindTools.cmake)
include(${CMAKE_SOURCE_DIR}/cmake/BuildLibrary.cmake)
include(${CMAKE_SOURCE_DIR}/cmake/BuildExecutable.cmake)

IF (APPLE)
  set(BININSTDIR "${PROJECT_NAME}.app/Contents/MacOS")
  SET(LIBINSTDIR "${PROJECT_NAME}.app/Contents/Frameworks")
  SET(RESOURCEINSTDIR "${PROJECT_NAME}.app/Contents/Resources")
  SET(RPATH_PREFIX "${PROJECT_NAME}.app/Contents/Frameworks")
ELSE()
  set(BININSTDIR "bin")
  IF (WIN32)
    SET(LIBINSTDIR "bin")
  ELSEIF (USE_BUILD_SYSTEM_LIBDIR)
    # See https://cmake.org/cmake/help/latest/module/GNUInstallDirs.html for
    # the purpose of this module
    include(GNUInstallDirs)
    SET(LIBINSTDIR "${CMAKE_INSTALL_LIBDIR}" CACHE STRING "library directory")
  ELSE ()
    SET(LIBINSTDIR "lib" CACHE STRING "library directory")
  ENDIF ()
  SET(RESOURCEINSTDIR "share/${PROJECT_NAME}")
  SET(RPATH_PREFIX "$ORIGIN")
ENDIF()
SET(BINDIR "${CMAKE_BINARY_DIR}/${BININSTDIR}")
SET(LIBDIR "${CMAKE_BINARY_DIR}/${LIBINSTDIR}")
SET(RESOURCEDIR "${CMAKE_BINARY_DIR}/${RESOURCEINSTDIR}")

if (APPLE AND INSTALL_DEPEND STREQUAL "ON")
  set(OBJECT_FIXUP_REQUIRED "ON")
else()
  set(OBJECT_FIXUP_REQUIRED "OFF")
endif()

file(RELATIVE_PATH RPATH "${BINDIR}" "${LIBDIR}")
SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
SET(CMAKE_SKIP_BUILD_RPATH  FALSE)
SET(CMAKE_INSTALL_RPATH "${RPATH_PREFIX}/${RPATH}")
SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH FALSE)

# setup compiler flags for debug vs release compiles
add_option(-Wall)
if (CMAKE_BUILD_TYPE STREQUAL "Debug")
  add_option(-g3)
else()
  add_option(-O3)
  add_option(-g)
  add_definitions(-DNDEBUG)
  add_option(-fomit-frame-pointer)
  add_option(-funroll-loops)
  add_option(-ffast-math)
endif ()

if (RTAUDIO_USE_JACK OR RTMIDI_USE_JACK OR GO_USE_JACK)
  pkg_check_modules(JACK REQUIRED IMPORTED_TARGET jack)
endif()

# Add ASIO variable
if(WIN32 AND RTAUDIO_USE_ASIO)
  add_definitions(-DASIO_INCLUDED)
endif()

if(RTAUDIO_USE_ASIO AND NOT ASIO_SDK_DIR)
  set(ASIO_SDK_DIR "${CMAKE_SOURCE_DIR}/ext/rt/asio")
endif()

# include RtAudio
if (USE_INTERNAL_RTAUDIO)
  if(NOT RTAUDIO_SRC_DIR)
    set(RTAUDIO_SRC_DIR "${CMAKE_SOURCE_DIR}/submodules/RtAudio")
    if(NOT EXISTS "${RTAUDIO_SRC_DIR}/RtAudio.h")
      message(
        FATAL_ERROR 
        "${RTAUDIO_SRC_DIR}/RtAudio.h file does not exist."
        "Possible the RtAudio submodule has not been updated."
        "Try to execute 'git submodule update --init --recursive' in the source directory"
      )
    endif()
  endif()
  if(NOT RTMIDI_SRC_DIR)
    set(RTMIDI_SRC_DIR "${CMAKE_SOURCE_DIR}/submodules/RtMidi")
    if(NOT EXISTS "${RTMIDI_SRC_DIR}/RtMidi.h")
      message(
        FATAL_ERROR 
        "${RTMIDI_SRC_DIR}/RtMidi.h file does not exist."
        "Possible the RtMidi submodule has not been updated."
        "Try to execute 'git submodule update --init --recursive' in the source directory"
      )
    endif()
  endif()
  add_subdirectory(src/rt)
  set(RT_LIBRARIES RtAudio RtMidi)
  set(RT_INCLUDE_DIRS ${RTMIDI_SRC_DIR} ${RTAUDIO_SRC_DIR})
else()
  pkg_check_modules(RTAUDIO REQUIRED rtaudio)
  pkg_check_modules(RTMIDI REQUIRED rtmidi)
  set(RT_LIBRARIES ${RTAUDIO_LIBRARIES} ${RTMIDI_LIBRARIES})
  set(RT_INCLUDE_DIRS ${RTMIDI_INCLUDE_DIRS} ${RTAUDIO_INCLUDE_DIRS})
endif()

# include portaudio
if (USE_INTERNAL_PORTAUDIO)
  set(PORTAUDIO_INCLUDE_DIRS ${CMAKE_SOURCE_DIR}/submodules/PortAudio/include)
  add_subdirectory(src/portaudio)
  set(PORTAUDIO_LIBRARIES PortAudio)
else()
  pkg_check_modules(PORTAUDIO REQUIRED portaudio-2.0)
endif()

# include zitaconvolver
if (USE_INTERNAL_ZITACONVOLVER)
  set(ZITACONVOLVER_INCLUDE_DIRS ${CMAKE_SOURCE_DIR}/submodules/ZitaConvolver/source)
  set(ZITACONVOLVER_LIBRARIES "")
else()
  set(ZITACONVOLVER_INCLUDE_DIRS "")
  set(ZITACONVOLVER_LIBRARIES zita-convolver)
endif()

# include libcurl for automatic cheking for updates
# exports CURL::libcurl that can be used in target_link_libraries
find_package(CURL REQUIRED)

# include FFTW
pkg_check_modules(FFTW REQUIRED fftw3f)

pkg_check_modules(ZLIB REQUIRED zlib)

pkg_check_modules(WAVPACK REQUIRED wavpack)

find_package(wxWidgets REQUIRED base)
message(STATUS "  wxWidgets Unicode?          : ${wxWidgets_USE_UNICODE}")
message(STATUS "  wxWidgets Debug?            : ${wxWidgets_USE_DEBUG}")
message(STATUS "  wxWidgets Static linking    : ${wxWidgets_USE_STATIC}")
message(STATUS "  wxWidgets version           : ${wxWidgets_VERSION}")
message(STATUS "  wxWidgets config binary     : ${wxWidgets_CONFIG_EXECUTABLE}")
message(STATUS "  wxWidgets configuration     : ${wxWidgets_CONFIGURATION}")
message(STATUS "============================================================================")

add_subdirectory(src/build)
add_subdirectory(src/images)
add_subdirectory(src/core)
add_subdirectory(src/grandorgue)
add_subdirectory(src/tools)
add_subdirectory(po)
add_subdirectory(help)
add_subdirectory(sounds)
add_subdirectory(packages)
add_subdirectory(perftests)
add_subdirectory(resources)


# packaging

# deal with possible package names among grandorgue, grandorgue-wx30, grandorgue-wx32
set(BASE_PACKAGE_NAME "grandorgue")

set(OTHER_PACKAGE_NAMES "${BASE_PACKAGE_NAME}" "${BASE_PACKAGE_NAME}-wx30" "${BASE_PACKAGE_NAME}-wx32")
set(CPACK_PACKAGE_NAME "${BASE_PACKAGE_NAME}")
if(CMAKE_PACKAGE_SUFFIX)
  set(CPACK_PACKAGE_NAME "${BASE_PACKAGE_NAME}-${CMAKE_PACKAGE_SUFFIX}")
endif()
list(REMOVE_ITEM OTHER_PACKAGE_NAMES "${CPACK_PACKAGE_NAME}")
if(NOT GO_SEPARATE_LINUX_PACKAGES)
  # For automatic removal of previously installed subpackages
  list(APPEND OTHER_PACKAGE_NAMES "${BASE_PACKAGE_NAME}-resources" "${BASE_PACKAGE_NAME}-demo")
endif()

set(CPACK_PACKAGE_VENDOR "GrandOrgue contributors")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "OpenSource Virtual Pipe Organ Software")
set(
  CPACK_PACKAGE_DESCRIPTION
  "GrandOrgue is a virtual pipe organ sample player application"
)
set(CPACK_PACKAGE_VERSION ${PROJECT_VERSION})
set(CPACK_PACKAGE_RELEASE ${BUILD_VERSION})

set(CPACK_PACKAGE_INSTALL_DIRECTORY "GrandOrgue")
set(CPACK_RESOURCE_FILE_LICENSE ${CMAKE_SOURCE_DIR}/LICENSE)
set(CPACK_PACKAGE_CONTACT "osamarin68@gmail.com")
set(CPACK_PACKAGE_EXECUTABLES "GrandOrgue" "GrandOrgue")

set(CPACK_SOURCE_IGNORE_FILES "/\\\\.git/" "/build/")

# components
set(CPACK_COMPONENTS_ALL Unspecified resources demo)
set(CPACK_COMPONENT_UNSPECIFIED_DISPLAY_NAME "GrandOrgue")

set(CPACK_COMPONENT_RESOURCES_DISPLAY_NAME "GrandOrgue Resource Files")
set(
  CPACK_COMPONENT_RESOURCES_DESCRIPTION
  "This package contains the various resource files for GrandOrgue"
)

set(CPACK_COMPONENT_DEMO_DISPLAY_NAME "GrandOrgue Demo Sampleset")
set(
  CPACK_COMPONENT_DEMO_DESCRIPTION 
  "This package contains the demo sampleset for GrandOrgue"
)

set(CPACK_COMPONENT_UNSPECIFIED_HIDDEN OFF)
set(CPACK_COMPONENT_UNSPECIFIED_DEPENDS resources)
set(CPACK_COMPONENT_DEMO_DEPENDS Unspecified)

if (APPLE)
  # see the following URL for information about these variables
  # https://developer.apple.com/library/mac/#documentation/General/Reference/InfoPlistKeyReference/Articles/CoreFoundationKeys.html
  set(BUNDLE_CFBundleShortVersionString ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_STAGE})
  set(BUNDLE_CFBundleVersion ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_STAGE})

  set(CPACK_PACKAGE_ICON "${RESOURCEDIR}/GrandOrgue.icns")

  configure_file(${CMAKE_SOURCE_DIR}/src/grandorgue/resource/Info.plist.in ${CMAKE_BINARY_DIR}/${PROJECT_NAME}.app/Contents/Info.plist)
  INSTALL(FILES ${CMAKE_BINARY_DIR}/${PROJECT_NAME}.app/Contents/Info.plist DESTINATION "${PROJECT_NAME}.app/Contents/")

  add_custom_target(
    macOSApplication
    ALL
    DEPENDS GrandOrgue GrandOrgueTool GrandOrguePerfTest resources # run after building these targets
    COMMAND "${CMAKE_COMMAND}" -DAPP_DIR="${CMAKE_BINARY_DIR}" -P "${CMAKE_SOURCE_DIR}/cmake/SignMacOSApp.cmake"
  )

  set(CPACK_SYSTEM_NAME "macOS")
  set(CPACK_GENERATOR DragNDrop)
  set(CPACK_PRE_BUILD_SCRIPTS "${CMAKE_SOURCE_DIR}/cmake/SignMacOSApp.cmake")

elseif (WIN32)

  if(CMAKE_BUILD_TYPE STREQUAL "Debug")
    set(CPACK_STRIP_FILES OFF)
  else()
    set(CPACK_STRIP_FILES ON)
  endif()

  set (CPACK_SYSTEM_NAME "windows")
  set (CPACK_GENERATOR ZIP NSIS)
  SET(CPACK_NSIS_EXTRA_INSTALL_COMMANDS "
    WriteRegStr HKCR \\\".organ\\\" \\\"\\\" \\\"GrandOrgue.odf\\\"
    WriteRegStr HKCR \\\".orgue\\\" \\\"\\\" \\\"GrandOrgue.package\\\"
    WriteRegStr HKCR \\\"GrandOrgue.odf\\\" \\\"\\\" \\\"GrandOrgue organ definition file\\\"

=== src/core/CMakeLists.txt ===
# Copyright 2006 Milan Digital Audio LLC
# Copyright 2009-2024 GrandOrgue contributors (see AUTHORS)
# License GPL-2.0 or later (https://www.gnu.org/licenses/old-licenses/gpl-2.0.html).

include(UsewxWidgets)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/go_defs.h.in ${CMAKE_CURRENT_BINARY_DIR}/go_defs.h/go_defs.h)
include_directories(${WAVPACK_INCLUDE_DIRS})
include_directories(${ZLIB_INCLUDE_DIRS})
include_directories(${CMAKE_CURRENT_BINARY_DIR}/go_defs.h)
include_directories(${CMAKE_CURRENT_SOURCE_DIR})

set(src
archive/GOArchive.cpp
archive/GOArchiveCreator.cpp
archive/GOArchiveFile.cpp
archive/GOArchiveIndex.cpp
archive/GOArchiveEntryFile.cpp
archive/GOArchiveManager.cpp
archive/GOArchiveReader.cpp
archive/GOArchiveWriter.cpp
config/GOConfigFileReader.cpp
config/GOConfigFileWriter.cpp
config/GOConfigReader.cpp
config/GOConfigReaderDB.cpp
config/GOConfigWriter.cpp
contrib/sha1.cpp
files/GOInvalidFile.cpp
files/GOStandardFile.cpp
files/GOStdFileName.cpp
midi/GOMidiEvent.cpp
midi/GOMidiFileReader.cpp
midi/GOMidiMap.cpp
midi/GOMidiEventPattern.cpp
midi/GOMidiReceiverBase.cpp
midi/GOMidiReceiverEventPattern.cpp
midi/GOMidiSenderEventPattern.cpp
midi/GOMidiWXEvent.cpp
settings/GOSetting.cpp
settings/GOSettingBool.cpp
settings/GOSettingDirectory.cpp
settings/GOSettingEnum.cpp
settings/GOSettingFile.cpp
settings/GOSettingFloat.cpp
settings/GOSettingStore.cpp
settings/GOSettingString.cpp
threading/GOCondition.cpp
threading/GOMutex.cpp
threading/GOMutexLocker.cpp
threading/GOThread.cpp
threading/threading_impl.cpp
temperaments/GOTemperament.cpp
temperaments/GOTemperamentCent.cpp
temperaments/GOTemperamentList.cpp
temperaments/GOTemperamentUser.cpp
GOCompress.cpp
GOHash.cpp
GOKeyConvert.cpp
GOLogicalColour.cpp
GOMemoryPool.cpp
GOOrgan.cpp
GOOrganList.cpp
GOPath.cpp
GORodgers.cpp
GOSampleStatistic.cpp
GOStdPath.cpp
GOTimer.cpp
GOUtil.cpp
GOWave.cpp
GOWavPack.cpp
GOWavPackWriter.cpp
)

BUILD_LIBRARY(GrandOrgueCore ${src})
target_link_libraries(GrandOrgueCore ${wxWidgets_LIBRARIES} ${WAVPACK_LIBRARIES} ${ZLIB_LIBRARIES})
link_directories(${wxWidgets_LIBRARY_DIRS} ${WAVPACK_LIBDIR} ${ZLIB_LIBDIR})

=== src/grandorgue/CMakeLists.txt ===
--- 
+++ 
@@ -55,7 +55,10 @@
 combinations/model/GOGeneralCombination.cpp
 combinations/GODivisionalSetter.cpp
 combinations/GOSetter.cpp
+config/GOAudioDeviceConfig.cpp
+config/GOAudioDeviceNode.cpp
 config/GOConfig.cpp
+config/GODeviceNamePattern.cpp
 config/GOMidiDeviceConfig.cpp
 config/GOMidiDeviceConfigList.cpp
 config/GOPortsConfig.cpp
@@ -76,10 +79,10 @@
 dialogs/midi-event/GOMidiEventRecvTab.cpp
 dialogs/midi-event/GOMidiEventSendTab.cpp
 dialogs/settings/GOSettingsAudio.cpp
+dialogs/settings/GOSettingsDeviceMatchDialog.cpp
 dialogs/settings/GOSettingsDialog.cpp
 dialogs/settings/GOSettingsMidiDeviceList.cpp
 dialogs/settings/GOSettingsMidiDevices.cpp
-dialogs/settings/GOSettingsMidiMatchDialog.cpp
 dialogs/settings/GOSettingsMidiMessage.cpp
 dialogs/settings/GOSettingsPaths.cpp
 dialogs/settings/GOSettingsPorts.cpp
@@ -93,6 +96,7 @@
 dialogs/GOProgressDialog.cpp
 dialogs/GOSelectOrganDialog.cpp
 dialogs/GOSplash.cpp
+dialogs/GOStopsDialog.cpp
 document-base/GODocumentBase.cpp
 document-base/GOView.cpp
 gui/primitives/GOBitmap.cpp
@@ -179,16 +183,18 @@
 sound/ports/GOSoundPortFactory.cpp
 sound/ports/GOSoundPortaudioPort.cpp
 sound/ports/GOSoundRtPort.cpp
-sound/scheduler/GOSoundGroupWorkItem.cpp
-sound/scheduler/GOSoundOutputWorkItem.cpp
-sound/scheduler/GOSoundReleaseWorkItem.cpp
+sound/scheduler/GOSoundGroupTask.cpp
+sound/scheduler/GOSoundOutputTask.cpp
+sound/scheduler/GOSoundReleaseTask.cpp
 sound/scheduler/GOSoundScheduler.cpp
 sound/scheduler/GOSoundThread.cpp
-sound/scheduler/GOSoundTouchWorkItem.cpp
-sound/scheduler/GOSoundTremulantWorkItem.cpp
-sound/scheduler/GOSoundWindchestWorkItem.cpp
+sound/scheduler/GOSoundTouchTask.cpp
+sound/scheduler/GOSoundTremulantTask.cpp
+sound/scheduler/GOSoundWindchestTask.cpp
 sound/GOSoundAudioSection.cpp
+sound/GOSoundDevInfo.cpp
 sound/GOSoundEngine.cpp
+sound/GOSoundFader.cpp
 sound/GOSoundProvider.cpp
 sound/GOSoundProviderSynthedTrem.cpp
 sound/GOSoundProviderWave.cpp
@@ -200,7 +206,10 @@
 sound/GOSoundResample.cpp
 sound/GOSoundSamplerPool.cpp
 sound/GOSoundStateHandler.cpp
+sound/GOSoundStream.cpp
 sound/GOSound.cpp
+sound/GOSoundFilter.cpp
+sound/GOSoundToneBalanceFilter.cpp
 updater/GOUpdateChecker.cpp
 yaml/GOSaveableToYaml.cpp
 yaml/go-wx-yaml.cpp

=== debian/changelog ===
grandorgue (3.15.0-1) unstable; urgency=medium

  * New upstream version 3.15.0

 -- Sébastien Villemot <sebastien@debian.org>  Fri, 09 Aug 2024 11:13:51 +0200

## grandorgue 3.15.1

=== debian/changelog ===
grandorgue (3.15.1-1) unstable; urgency=medium

  * New upstream version 3.15.1

 -- Sébastien Villemot <sebastien@debian.org>  Sun, 08 Sep 2024 10:01:00 +0200

## grandorgue 3.15.2

=== debian/changelog ===
grandorgue (3.15.2-1) unstable; urgency=medium

  * New upstream version 3.15.2

 -- Sébastien Villemot <sebastien@debian.org>  Sat, 26 Oct 2024 18:55:11 +0200

## grandorgue 3.15.3

=== src/grandorgue/CMakeLists.txt ===
--- 
+++ 
@@ -69,64 +69,72 @@
 control/GOEventDistributor.cpp
 control/GOLabelControl.cpp
 control/GOPistonControl.cpp
-dialogs/common/GODialogCloser.cpp
-dialogs/common/GODialogSizeSet.cpp
-dialogs/common/GODialogTab.cpp
-dialogs/common/GOSimpleDialog.cpp
-dialogs/common/GOTabbedDialog.cpp
-dialogs/midi-event/GOMidiEventDialog.cpp
-dialogs/midi-event/GOMidiEventKeyTab.cpp
-dialogs/midi-event/GOMidiEventRecvTab.cpp
-dialogs/midi-event/GOMidiEventSendTab.cpp
-dialogs/settings/GOSettingsAudio.cpp
-dialogs/settings/GOSettingsDeviceMatchDialog.cpp
-dialogs/settings/GOSettingsDialog.cpp
-dialogs/settings/GOSettingsMidiDeviceList.cpp
-dialogs/settings/GOSettingsMidiDevices.cpp
-dialogs/settings/GOSettingsMidiMessage.cpp
-dialogs/settings/GOSettingsPaths.cpp
-dialogs/settings/GOSettingsPorts.cpp
-dialogs/settings/GOSettingsOptions.cpp
-dialogs/settings/GOSettingsOrgans.cpp
-dialogs/settings/GOSettingsReverb.cpp
-dialogs/settings/GOSettingsTemperaments.cpp
-dialogs/GOMidiListDialog.cpp
-dialogs/GONewReleaseDialog.cpp
-dialogs/GOOrganSettingsDialog.cpp
-dialogs/GOProgressDialog.cpp
-dialogs/GOSelectOrganDialog.cpp
-dialogs/GOSplash.cpp
-dialogs/GOStopsDialog.cpp
 document-base/GODocumentBase.cpp
 document-base/GOView.cpp
-gui/primitives/GOBitmap.cpp
-gui/primitives/GODC.cpp
-gui/primitives/GOFont.cpp
-gui/primitives/go_gui_utils.cpp
-gui/GOGUIBankedGeneralsPanel.cpp
-gui/GOGUIButton.cpp
-gui/GOGUICrescendoPanel.cpp
-gui/GOGUIControl.cpp
-gui/GOGUICouplerPanel.cpp
-gui/GOGUIDisplayMetrics.cpp
-gui/GOGUIDivisionalsPanel.cpp
-gui/GOGUIEnclosure.cpp
-gui/GOGUIFloatingPanel.cpp
-gui/GOGUIHW1Background.cpp
-gui/GOGUIHW1DisplayMetrics.cpp
-gui/GOGUIImage.cpp
-gui/GOGUILayoutEngine.cpp
-gui/GOGUIPanelView.cpp
-gui/GOGUISetterDisplayMetrics.cpp
-gui/GOGUILabel.cpp
-gui/GOGUIManual.cpp
-gui/GOGUIManualBackground.cpp
-gui/GOGUIMasterPanel.cpp
-gui/GOGUIMetronomePanel.cpp
-gui/GOGUIPanel.cpp
-gui/GOGUIPanelWidget.cpp
-gui/GOGUIRecorderPanel.cpp
-gui/GOGUISequencerPanel.cpp
+gui/dialogs/common/GODialogCloser.cpp
+gui/dialogs/common/GODialogSizeSet.cpp
+gui/dialogs/common/GODialogTab.cpp
+gui/dialogs/common/GOSimpleDialog.cpp
+gui/dialogs/common/GOTabbedDialog.cpp
+gui/dialogs/midi-event/GOMidiEventDialog.cpp
+gui/dialogs/midi-event/GOMidiEventKeyTab.cpp
+gui/dialogs/midi-event/GOMidiEventRecvTab.cpp
+gui/dialogs/midi-event/GOMidiEventSendTab.cpp
+gui/dialogs/settings/GOSettingsAudio.cpp
+gui/dialogs/settings/GOSettingsDeviceMatchDialog.cpp
+gui/dialogs/settings/GOSettingsDialog.cpp
+gui/dialogs/settings/GOSettingsMidiDeviceList.cpp
+gui/dialogs/settings/GOSettingsMidiDevices.cpp
+gui/dialogs/settings/GOSettingsMidiMessage.cpp
+gui/dialogs/settings/GOSettingsPaths.cpp
+gui/dialogs/settings/GOSettingsPorts.cpp
+gui/dialogs/settings/GOSettingsOptions.cpp
+gui/dialogs/settings/GOSettingsOrgans.cpp
+gui/dialogs/settings/GOSettingsReverb.cpp
+gui/dialogs/settings/GOSettingsTemperaments.cpp
+gui/dialogs/GOMidiListDialog.cpp
+gui/dialogs/GONewReleaseDialog.cpp
+gui/dialogs/GOOrganSettingsDialog.cpp
+gui/dialogs/GOProgressDialog.cpp
+gui/dialogs/GOPropertiesDialog.cpp
+gui/dialogs/GOSelectOrganDialog.cpp
+gui/dialogs/GOSplash.cpp
+gui/frames/GOFrame.cpp
+gui/frames/GOLogWindow.cpp
+gui/frames/GOMainWindowData.cpp
+gui/frames/GOStopsWindow.cpp
+gui/panels/primitives/GOBitmap.cpp
+gui/panels/primitives/GODC.cpp
+gui/panels/primitives/GOFont.cpp
+gui/panels/GOGUIBankedGeneralsPanel.cpp
+gui/panels/GOGUIButton.cpp
+gui/panels/GOGUICrescendoPanel.cpp
+gui/panels/GOGUIControl.cpp
+gui/panels/GOGUICouplerPanel.cpp
+gui/panels/GOGUIDisplayMetrics.cpp
+gui/panels/GOGUIDivisionalsPanel.cpp
+gui/panels/GOGUIEnclosure.cpp
+gui/panels/GOGUIFloatingPanel.cpp
+gui/panels/GOGUIHW1Background.cpp
+gui/panels/GOGUIHW1DisplayMetrics.cpp
+gui/panels/GOGUIImage.cpp
+gui/panels/GOGUILayoutEngine.cpp
+gui/panels/GOGUIPanelView.cpp
+gui/panels/GOGUISetterDisplayMetrics.cpp
+gui/panels/GOGUILabel.cpp
+gui/panels/GOGUIManual.cpp
+gui/panels/GOGUIManualBackground.cpp
+gui/panels/GOGUIMasterPanel.cpp
+gui/panels/GOGUIMetronomePanel.cpp
+gui/panels/GOGUIPanel.cpp
+gui/panels/GOGUIPanelWidget.cpp
+gui/panels/GOGUIRecorderPanel.cpp
+gui/panels/GOGUISequencerPanel.cpp
+gui/size/GOSizeKeeper.cpp
+gui/wxcontrols/GOAudioGauge.cpp
+gui/wxcontrols/GOGrid.cpp
+gui/wxcontrols/GORightVisiblePicker.cpp
+gui/wxcontrols/go_gui_utils.cpp
 help/GOHelpController.cpp
 help/GOHelpRequestor.cpp
 loader/GOFileStore.cpp
@@ -171,13 +179,13 @@
 model/GOPipe.cpp
 model/GORank.cpp
 model/GOReferencePipe.cpp
+model/GOReferencingObject.cpp
 model/GOSoundingPipe.cpp
 model/GOStop.cpp
 model/GOSwitch.cpp
 model/GOTremulant.cpp
 model/GOWindchest.cpp
 modification/GOModificationProxy.cpp
-size/GOSizeKeeper.cpp
 sound/ports/GOSoundJackPort.cpp
 sound/ports/GOSoundPort.cpp
 sound/ports/GOSoundPortFactory.cpp
@@ -213,19 +221,12 @@
 updater/GOUpdateChecker.cpp
 yaml/GOSaveableToYaml.cpp
 yaml/go-wx-yaml.cpp
-wxcontrols/GOAudioGauge.cpp
-wxcontrols/GOGrid.cpp
-wxcontrols/GORightVisiblePicker.cpp
 GOAudioRecorder.cpp
 GOBitmapCache.cpp
 GOEvent.cpp
 GOLog.cpp
-GOLogWindow.cpp
 GOMetronome.cpp
-GOMainWindowData.cpp
 GOOrganController.cpp
-GOProperties.cpp
-GOFrame.cpp
 GODocument.cpp
 GOVirtualCouplerController.cpp
 )

=== src/tests/CMakeLists.txt ===
add_option(-mmmx)
add_option(-msse)
add_option(-msse2)
add_option(-msse3)

add_option(-mstackrealign)

include(UsewxWidgets)
include_directories(${CMAKE_BINARY_DIR}/src/core/go_defs.h ${CMAKE_SOURCE_DIR}/src/core)

add_subdirectory(common)
add_subdirectory(testing)

add_executable(GOTestExe GOTestExe.cpp)


target_link_libraries(GOTestExe GOTestLib)
target_link_libraries(GOTestExe golib)
target_link_libraries(GOTestExe GOTests)
target_include_directories(GOTestExe PUBLIC ${CMAKE_SOURCE_DIR}/src/tests)
target_include_directories(GOTestExe PUBLIC ${CMAKE_SOURCE_DIR}/src/tests/common)
target_include_directories(GOTestExe PUBLIC ${CMAKE_SOURCE_DIR}/src/tests/testing)
target_include_directories(GOTestExe PUBLIC ${CMAKE_SOURCE_DIR}/src/tests/testing/model)
target_include_directories(GOTests PUBLIC ${CMAKE_SOURCE_DIR}/src/tests/common)
BUILD_EXECUTABLE(GOTestExe)

add_test(NAME GOTestExe COMMAND GOTestExe)
include(CTest)

=== debian/changelog ===
grandorgue (3.15.3-1ubuntu1) plucky; urgency=medium

  * d/control: build with imagemagick 7

 -- Andreas Hasenack <andreas@canonical.com>  Tue, 10 Dec 2024 18:16:34 +0000

grandorgue (3.15.3-1) unstable; urgency=medium

  * New upstream version 3.15.3

 -- Sébastien Villemot <sebastien@debian.org>  Sun, 01 Dec 2024 10:32:30 +0100

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,6 @@
 Source: grandorgue
-Maintainer: Sébastien Villemot <sebastien@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Sébastien Villemot <sebastien@debian.org>
 Section: sound
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
@@ -15,7 +16,7 @@
                libzita-convolver-dev,
                libyaml-cpp-dev,
                libcurl4-openssl-dev,
-               imagemagick-6.q16,
+               imagemagick-7.q16,
                librsvg2-bin,
                gettext,
                xsltproc,

## grandorgue 3.15.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -27,6 +27,11 @@
   set(BUILD_VERSION "0.local")
 elseif(NOT BUILD_VERSION)
   set(BUILD_VERSION "0.0")
+endif()
+
+
+if (NOT DEFINED GO_BUILD_TESTING OR GO_BUILD_TESTING STREQUAL "")
+  set(GO_BUILD_TESTING ${BUILD_TESTING})
 endif()
 
 set(FULL_VERSION "${PROJECT_VERSION}-${BUILD_VERSION}")
@@ -211,6 +216,15 @@
 message(STATUS "  wxWidgets configuration     : ${wxWidgets_CONFIGURATION}")
 message(STATUS "============================================================================")
 
+
+if (GO_BUILD_TESTING)
+    # Add coverage configuration to include project files - Don't put extra libraries here under
+    set(CMAKE_CXX_FLAGS_DEBUG "-g --coverage")
+    message(STATUS "============================================================================")
+    message(STATUS " Coverage enabled")
+    message(STATUS "============================================================================")
+endif()
+
 add_subdirectory(src/build)
 add_subdirectory(src/images)
 add_subdirectory(src/core)
@@ -223,6 +237,15 @@
 add_subdirectory(perftests)
 add_subdirectory(resources)
 
+if (GO_BUILD_TESTING)
+  enable_testing()
+  add_subdirectory(src/tests)
+  
+  message(STATUS "============================================================================")
+  message(STATUS " Testing enabled")
+  message(STATUS "============================================================================")
+endif()
+
 
 # packaging
 
@@ -290,25 +313,3 @@
   add_custom_target(
     macOSApplication
     ALL
-    DEPENDS GrandOrgue GrandOrgueTool GrandOrguePerfTest resources # run after building these targets
-    COMMAND "${CMAKE_COMMAND}" -DAPP_DIR="${CMAKE_BINARY_DIR}" -P "${CMAKE_SOURCE_DIR}/cmake/SignMacOSApp.cmake"
-  )
-
-  set(CPACK_SYSTEM_NAME "macOS")
-  set(CPACK_GENERATOR DragNDrop)
-  set(CPACK_PRE_BUILD_SCRIPTS "${CMAKE_SOURCE_DIR}/cmake/SignMacOSApp.cmake")
-
-elseif (WIN32)
-
-  if(CMAKE_BUILD_TYPE STREQUAL "Debug")
-    set(CPACK_STRIP_FILES OFF)
-  else()
-    set(CPACK_STRIP_FILES ON)
-  endif()
-
-  set (CPACK_SYSTEM_NAME "windows")
-  set (CPACK_GENERATOR ZIP NSIS)
-  SET(CPACK_NSIS_EXTRA_INSTALL_COMMANDS "
-    WriteRegStr HKCR \\\".organ\\\" \\\"\\\" \\\"GrandOrgue.odf\\\"
-    WriteRegStr HKCR \\\".orgue\\\" \\\"\\\" \\\"GrandOrgue.package\\\"
-    WriteRegStr HKCR \\\"GrandOrgue.odf\\\" \\\"\\\" \\\"GrandOrgue organ definition file\\\"

=== perftests/CMakeLists.txt ===
# Copyright 2006 Milan Digital Audio LLC
# Copyright 2009-2021 GrandOrgue contributors (see AUTHORS)
# License GPL-2.0 or later
# (https://www.gnu.org/licenses/old-licenses/gpl-2.0.html).

include(${CMAKE_SOURCE_DIR}/cmake/CopyStructure.cmake)

file(MAKE_DIRECTORY ${RESOURCEDIR}/perftests)
install(DIRECTORY DESTINATION ${RESOURCEINSTDIR}/perftests)
COPY_STRUCTURE(perftests "perftests" resources)

=== src/core/CMakeLists.txt ===
--- 
+++ 
@@ -59,7 +59,6 @@
 GOMemoryPool.cpp
 GOOrgan.cpp
 GOOrganList.cpp
-GOPath.cpp
 GORodgers.cpp
 GOSampleStatistic.cpp
 GOStdPath.cpp
@@ -68,6 +67,7 @@
 GOWave.cpp
 GOWavPack.cpp
 GOWavPackWriter.cpp
+go_path.cpp
 )
 
 BUILD_LIBRARY(GrandOrgueCore ${src})

=== src/grandorgue/CMakeLists.txt ===
--- 
+++ 
@@ -5,13 +5,7 @@
 include(${CMAKE_SOURCE_DIR}/cmake/AddLinkerOption.cmake)
 include(${CMAKE_SOURCE_DIR}/cmake/CopyWxTranslations.cmake)
 include(${CMAKE_SOURCE_DIR}/cmake/CopyDependencies.cmake)
-
-add_option(-mmmx)
-add_option(-msse)
-add_option(-msse2)
-add_option(-msse3)
-
-add_option(-mstackrealign)
+include(${CMAKE_SOURCE_DIR}/cmake/AddCpuOptions.cmake)
 
 find_package(wxWidgets REQUIRED html net adv core base)
 include(${wxWidgets_USE_FILE})

=== src/tests/testing/CMakeLists.txt ===
set(go_tests
    # Add here your tests files
    model/GOTestDrawStop.cpp
    model/GOTestOrganModel.cpp
    model/GOTestSwitch.cpp
    model/GOTestWindchest.cpp
)
add_library(GOTests STATIC ${go_tests})

target_link_libraries(GOTests GOTestLib)

=== debian/changelog ===
grandorgue (3.15.4-2) unstable; urgency=medium

  * Add docbook-xml to Build-Depends (Closes: #1104834)
  * Bump S-V to 4.7.2

 -- Sébastien Villemot <sebastien@debian.org>  Wed, 07 May 2025 11:56:49 +0200

grandorgue (3.15.4-1) unstable; urgency=medium

  * New upstream version 3.15.4

 -- Sébastien Villemot <sebastien@debian.org>  Tue, 24 Dec 2024 09:51:15 +0100

grandorgue (3.15.3-2) unstable; urgency=medium

  * Improve dependency constraints for building the icon.
    Restore Build-Depends on imagemagick, and add Build-Conflicts against
    graphicsmagick-imagemagick-compat (since the latter can be picked by the
    autobuilders, but fails at converting the SVG into an icon).
    (Closes: #1088875)

 -- Sébastien Villemot <sebastien@debian.org>  Wed, 18 Dec 2024 18:08:10 +0100

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: grandorgue
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Sébastien Villemot <sebastien@debian.org>
+Maintainer: Sébastien Villemot <sebastien@debian.org>
 Section: sound
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
@@ -16,14 +15,16 @@
                libzita-convolver-dev,
                libyaml-cpp-dev,
                libcurl4-openssl-dev,
-               imagemagick-7.q16,
+               imagemagick,
                librsvg2-bin,
                gettext,
                xsltproc,
+               docbook-xml,
                docbook-xsl,
                zip,
                po4a
-Standards-Version: 4.7.0
+Build-Conflicts: graphicsmagick-imagemagick-compat
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/debian/grandorgue
 Vcs-Git: https://salsa.debian.org/debian/grandorgue.git
 Homepage: https://github.com/GrandOrgue/grandorgue

## grandorgue 3.16.0

=== src/grandorgue/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 # Copyright 2006 Milan Digital Audio LLC
-# Copyright 2009-2024 GrandOrgue contributors (see AUTHORS)
+# Copyright 2009-2025 GrandOrgue contributors (see AUTHORS)
 # License GPL-2.0 or later (https://www.gnu.org/licenses/old-licenses/gpl-2.0.html).
 
 include(${CMAKE_SOURCE_DIR}/cmake/AddLinkerOption.cmake)
@@ -52,11 +52,13 @@
 config/GOAudioDeviceConfig.cpp
 config/GOAudioDeviceNode.cpp
 config/GOConfig.cpp
+config/GOConfigMidiObject.cpp
 config/GODeviceNamePattern.cpp
 config/GOMidiDeviceConfig.cpp
 config/GOMidiDeviceConfigList.cpp
 config/GOPortsConfig.cpp
 config/GOPortFactory.cpp
+config/GORegisteredOrgan.cpp
 control/GOButtonControl.cpp
 control/GOCallbackButtonControl.cpp
 control/GOElementCreator.cpp
@@ -74,25 +76,29 @@
 gui/dialogs/midi-event/GOMidiEventKeyTab.cpp
 gui/dialogs/midi-event/GOMidiEventRecvTab.cpp
 gui/dialogs/midi-event/GOMidiEventSendTab.cpp
+gui/dialogs/organ-settings/GOOrganSettingsTab.cpp
+gui/dialogs/organ-settings/GOOrganSettingsDialog.cpp
+gui/dialogs/organ-settings/GOOrganSettingsEnclosuresTab.cpp
+gui/dialogs/organ-settings/GOOrganSettingsPipesTab.cpp
 gui/dialogs/settings/GOSettingsAudio.cpp
 gui/dialogs/settings/GOSettingsDeviceMatchDialog.cpp
 gui/dialogs/settings/GOSettingsDialog.cpp
 gui/dialogs/settings/GOSettingsMidiDeviceList.cpp
 gui/dialogs/settings/GOSettingsMidiDevices.cpp
-gui/dialogs/settings/GOSettingsMidiMessage.cpp
+gui/dialogs/settings/GOSettingsMidiInitial.cpp
 gui/dialogs/settings/GOSettingsPaths.cpp
 gui/dialogs/settings/GOSettingsPorts.cpp
 gui/dialogs/settings/GOSettingsOptions.cpp
 gui/dialogs/settings/GOSettingsOrgans.cpp
 gui/dialogs/settings/GOSettingsReverb.cpp
 gui/dialogs/settings/GOSettingsTemperaments.cpp
-gui/dialogs/GOMidiListDialog.cpp
+gui/dialogs/GOMidiObjectsDialog.cpp
 gui/dialogs/GONewReleaseDialog.cpp
-gui/dialogs/GOOrganSettingsDialog.cpp
 gui/dialogs/GOProgressDialog.cpp
 gui/dialogs/GOPropertiesDialog.cpp
 gui/dialogs/GOSelectOrganDialog.cpp
 gui/dialogs/GOSplash.cpp
+gui/dialogs/go-message-boxes.cpp
 gui/frames/GOFrame.cpp
 gui/frames/GOLogWindow.cpp
 gui/frames/GOMainWindowData.cpp
@@ -113,6 +119,7 @@
 gui/panels/GOGUIHW1DisplayMetrics.cpp
 gui/panels/GOGUIImage.cpp
 gui/panels/GOGUILayoutEngine.cpp
+gui/panels/GOGUIMidiControl.cpp
 gui/panels/GOGUIPanelView.cpp
 gui/panels/GOGUISetterDisplayMetrics.cpp
 gui/panels/GOGUILabel.cpp
@@ -138,7 +145,26 @@
 loader/cache/GOCache.cpp
 loader/cache/GOCacheCleaner.cpp
 loader/cache/GOCacheWriter.cpp
-midi/dialog-creator/GOMidiDialogCreatorProxy.cpp
+midi/dialog-creator/GOMidiConfigDispatcher.cpp
+midi/elements/GOMidiReceiver.cpp
+midi/elements/GOMidiShortcutReceiver.cpp
+midi/elements/GOMidiSendProxy.cpp
+midi/elements/GOMidiSender.cpp
+midi/events/GOMidiEvent.cpp
+midi/events/GOMidiEventPattern.cpp
+midi/events/GOMidiReceiverEventPattern.cpp
+midi/events/GOMidiSenderEventPattern.cpp
+midi/events/GOMidiShortcutPattern.cpp
+midi/events/GOMidiWXEvent.cpp
+midi/events/GORodgers.cpp
+midi/files/GOMidiFileReader.cpp
+midi/objects/GOMidiObject.cpp
+midi/objects/GOMidiObjectContext.cpp
+midi/objects/GOMidiObjectWithDivision.cpp
+midi/objects/GOMidiObjectWithShortcut.cpp
+midi/objects/GOMidiPlayingObject.cpp
+midi/objects/GOMidiReceivingSendingObject.cpp
+midi/objects/GOMidiSendingObject.cpp
 midi/ports/GOMidiInPort.cpp
 midi/ports/GOMidiOutPort.cpp
 midi/ports/GOMidiPort.cpp
@@ -147,17 +173,12 @@
 midi/ports/GOMidiRtInPort.cpp
 midi/ports/GOMidiRtOutPort.cpp
 midi/GOMidi.cpp
-midi/GOMidiConfigurator.cpp
 midi/GOMidiInputMerger.cpp
 midi/GOMidiListener.cpp
+midi/GOMidiMap.cpp
 midi/GOMidiOutputMerger.cpp
 midi/GOMidiPlayer.cpp
 midi/GOMidiPlayerContent.cpp
-midi/GOMidiSendProxy.cpp
-midi/GOMidiSender.cpp
-midi/GOMidiShortcutPattern.cpp
-midi/GOMidiShortcutReceiver.cpp
-midi/GOMidiReceiver.cpp
 midi/GOMidiRecorder.cpp
 model/pipe-config/GOPipeConfig.cpp
 model/pipe-config/GOPipeConfigNode.cpp
@@ -165,7 +186,7 @@
 model/GOCacheObject.cpp
 model/GOCoupler.cpp
 model/GODivisionalCoupler.cpp
-model/GODrawStop.cpp
+model/GODrawstop.cpp
 model/GOEnclosure.cpp
 model/GOEventHandlerList.cpp
 model/GOManual.cpp
@@ -214,14 +235,16 @@
 sound/GOSoundToneBalanceFilter.cpp
 updater/GOUpdateChecker.cpp
 yaml/GOSaveableToYaml.cpp
+yaml/GOYamlModel.cpp
 yaml/go-wx-yaml.cpp
 GOAudioRecorder.cpp
 GOBitmapCache.cpp
+GODocument.cpp
 GOEvent.cpp
+GOKeyConvert.cpp
 GOLog.cpp
 GOMetronome.cpp
 GOOrganController.cpp
-GODocument.cpp
 GOVirtualCouplerController.cpp
 )
 
@@ -232,6 +255,7 @@
 add_library(golib STATIC ${grandorgue_src})
 set(go_libs ${wxWidgets_LIBRARIES} ${YAML_CPP_LIBRARIES} ${RT_LIBRARIES} ${PORTAUDIO_LIBRARIES} ${FFTW_LIBRARIES} ${ZITACONVOLVER_LIBRARIES} CURL::libcurl)
 set(go_libdir ${wxWidgets_LIBRARY_DIRS} ${RT_LIBDIR} ${PORTAUDIO_LIBDIR} ${FFTW_LIBDIR})
+target_include_directories(golib PUBLIC ${YAML_CPP_INCLUDE_DIRS})
 target_link_libraries(golib GrandOrgueImages GrandOrgueCore ${go_libs})
 link_directories(${go_libdir})

=== debian/changelog ===
grandorgue (3.16.0-1) unstable; urgency=medium

  * New upstream version 3.16.0
    + Fixes compilation against gcc-15 (Closes: #1096772)
  * d/copyright: reflect upstream changes
  * Drop “Rules-Requires-Root: no”, which is now the default

 -- Sébastien Villemot <sebastien@debian.org>  Mon, 11 Aug 2025 15:07:18 +0200
